petsc-3.12.1 2019-10-22
Report Typos and Errors

# SNESSetFunction

Sets the function evaluation routine and function vector for use by the SNES routines in solving systems of nonlinear equations.

### Synopsis

    #include "petscsnes.h"
    PetscErrorCode  SNESSetFunction(SNES snes,Vec r,PetscErrorCode (*f)(SNES,Vec,Vec,void*),void *ctx)

Logically Collective on SNES

### Input Parameters

| snes | - the SNES context
| r | - vector to store function value
| f | - function evaluation routine; see SNESFunction for calling sequence details
| ctx | - [optional] user-defined context for private data for the function evaluation routine (may be NULL)

### Notes

The Newton-like methods typically solve linear systems of the form

         f'(x) x = -f(x),

where f'(x) denotes the Jacobian matrix and f(x) is the function.

### See Also

SNESGetFunction(), SNESComputeFunction(), SNESSetJacobian(), SNESSetPicard(), SNESFunction

### Level

beginner

### Location

src/snes/interface/snes.c

### Examples

src/snes/examples/tutorials/ex1.c.html
src/snes/examples/tutorials/ex2.c.html
src/snes/examples/tutorials/ex3.c.html
src/snes/examples/tutorials/ex5.c.html
src/snes/examples/tutorials/ex14.c.html
src/snes/examples/tutorials/ex15.c.html
src/snes/examples/tutorials/ex18.c.html
src/snes/examples/tutorials/ex20.c.html
src/snes/examples/tutorials/ex21.c.html
src/snes/examples/tutorials/ex22.c.html
src/snes/examples/tutorials/ex28.c.html
Index of all SNES routines
Table of Contents for all manual pages
Index of all manual pages